Name:		fastdfs
Version:	5.0.7
Release:	7%{?dist}
Summary:	FastDFS server and client
License:	GPL
Group:		Arch/Tech
URL:		https://github.com/happyfish100/fastdfs

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 

Source0:	%{name}-%{version}.tar.gz

BuildRequires:	gcc
BuildRequires:  glibc-devel
BuildRequires:  libtool
BuildRequires:  make
BuildRequires:  perl,gawk
BuildRequires:	libfastcommon-devel >= 1.0.21
Requires(post): chkconfig

%description
This package provides tracker & storage of fastdfs

%package  tracker
Summary:  fastdfs tracker
Requires: fastdfs
Requires: libfastcommon >= 1.0.21

%package  storage
Summary:  fastdfs storage
Requires: fastdfs
Requires: libfastcommon >= 1.0.21

%package  tool
Summary:  fastdfs tools
Requires: fastdfs
Requires: libfastcommon >= 1.0.21

%package  -n libfdfsclient
Summary:  The client dynamic library of fastdfs
Requires: libfastcommon >= 1.0.21

%package  -n libfdfsclient-devel
Summary:  The client header of fastdfs
Requires: libfdfsclient

%description tracker
This package provides tracker of fastdfs

%description storage
This package provides storage of fastdfs

%description -n libfdfsclient
This package is client dynamic library of fastdfs

%description -n libfdfsclient-devel
This package is client header of fastdfs client

%description tool
This package is tools for fastdfs

%prep
%setup -q

%build
./make.sh

%install
rm -rf %{buildroot}
DESTDIR=$RPM_BUILD_ROOT ./make.sh install

%{__mkdir} -p $RPM_BUILD_ROOT%{_bindir}
%{__mkdir} -p $RPM_BUILD_ROOT%{_initrddir}
%{__mkdir} -p $RPM_BUILD_ROOT%{_sysconfdir}/fdfs
%{__mkdir} -p $RPM_BUILD_ROOT%{_datadir}/fastdfs/php-client
%{__mkdir} -p $RPM_BUILD_ROOT%{_sharedstatedir}/fastdfs/{client,storage,tracker}

rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/init.d/fdfs_storaged 
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/init.d/fdfs_trackerd
rm -rf $RPM_BUILD_ROOT%{_bindir}/restart.sh
rm -rf $RPM_BUILD_ROOT%{_bindir}/stop.sh
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/tracker.conf.sample
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/storage.conf.sample
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/client.conf.sample
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/storage_ids.conf.sample

# install SYSV init stuff
%{__cp} rpm/fdfs_trackerd.init $RPM_BUILD_ROOT%{_initrddir}/fdfs_trackerd
%{__cp} rpm/fdfs_storaged.init $RPM_BUILD_ROOT%{_initrddir}/fdfs_storaged

%{__cp} rpm/tracker.conf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/tracker.conf
%{__cp} rpm/storage.conf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/storage.conf
%{__cp} rpm/client.conf  $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/client.conf
%{__cp} rpm/http.conf    $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/http.conf

%{__cp} -f rpm/storage_ids.conf $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/storage_ids.conf
%{__cp} -f rpm/mime.types $RPM_BUILD_ROOT%{_sysconfdir}/fdfs/mime.types


%pre
# Add the "fdfs" user
getent group fdfs >/dev/null || groupadd -r fdfs
getent passwd fdfs >/dev/null || \
    useradd -r -g fdfs -s /sbin/nologin \
    -d /var/lib/fastdfs -c "fastdfs user"  fdfs
exit 0

%post tracker
chkconfig --add fdfs_trackerd
chkconfig fdfs_trackerd on

%preun tracker
service fdfs_trackerd stop >/dev/null 2>&1|| true
chkconfig --del fdfs_trackerd

%post storage
chkconfig --add fdfs_storaged
chkconfig fdfs_storaged on

%preun storage
service fdfs_storaged stop >/dev/null 2>&1|| true
chkconfig --del fdfs_storaged

%postun

%clean
rm -rf $RPM_BUILD_ROOT

pushd common;make -s clean ;popd
pushd tracker;make -s clean ;popd
pushd storage;make -s clean ;popd
pushd test;make -s clean ;popd
pushd client ;make -s clean ;popd

%files
%defattr(-,root,root,-)
%dir %{_sysconfdir}/fdfs
%dir %{_datadir}/fastdfs
%dir %attr(0755,fdfs,fdfs) %{_sharedstatedir}/fastdfs
%dir %attr(0755,fdfs,fdfs) %{_sharedstatedir}/fastdfs/client
%dir %attr(0755,fdfs,fdfs) %{_sharedstatedir}/fastdfs/storage
%dir %attr(0755,fdfs,fdfs) %{_sharedstatedir}/fastdfs/tracker

%files tracker
%defattr(-,root,root,-)
%{_bindir}/fdfs_trackerd
%{_initrddir}/fdfs_trackerd
%config(noreplace) %{_sysconfdir}/fdfs/tracker.conf

%files storage
%defattr(-,root,root,-)
%{_bindir}/fdfs_storaged
%{_initrddir}/fdfs_storaged
%config(noreplace) %{_sysconfdir}/fdfs/storage.conf

%files -n libfdfsclient
%{_libdir}/libfdfsclient*
%config(noreplace) %{_sysconfdir}/fdfs/client.conf
%config(noreplace) %{_sysconfdir}/fdfs/http.conf
%config(noreplace) %{_sysconfdir}/fdfs/mime.types
%config(noreplace) %{_sysconfdir}/fdfs/storage_ids.conf

%files -n libfdfsclient-devel
%defattr(-,root,root,-)
%{_includedir}/fastdfs/*

%files tool
%{_bindir}/fdfs_monitor
%{_bindir}/fdfs_test
%{_bindir}/fdfs_test1
%{_bindir}/fdfs_crc32
%{_bindir}/fdfs_upload_file
%{_bindir}/fdfs_download_file
%{_bindir}/fdfs_delete_file
%{_bindir}/fdfs_file_info
%{_bindir}/fdfs_appender_test
%{_bindir}/fdfs_appender_test1
%{_bindir}/fdfs_append_file
%{_bindir}/fdfs_upload_appender

%changelog
* Fri Nov 06 2015  Purple Grape <purplegrape4@gmail.com>
- update to v5.0.7

* Thu Nov 05 2015  Purple Grape <purplegrape4@gmail.com>
- update to v5.0.5
- new init scripts
- run as user fdfs by default

* Mon Jun 23 2014  Zaixue Liao <liaozaixue@yongche.com>
- first RPM release (1.0)
